﻿using System;
using System.Net;
using System.Windows;
using Telerik.Windows.Data;
using TreeViewAndJSON.Helpers;

namespace TreeViewAndJSON.ViewModels
{
	public class CategoryViewModel : ViewModelBase
	{
		public CategoryViewModel()
		{
			this.Children = new RadObservableCollection<ViewModelBase>();
		}

		public string CatName
		{
			get;
			set;
		}

		public RadObservableCollection<ViewModelBase> Children
		{
			get;
			set;
		}

		public int IDCategory
		{
			get;
			set;
		}

		public void LoadImages()
		{
			WebClient webClient = new WebClient();
			webClient.OpenReadCompleted += this.CategoryReadCompleted;
			webClient.OpenReadAsync(new Uri(string.Format("{0}?QType=NextCatChildren&IDCat={1}", UrlHelper.QueryURl, this.IDCategory)));
		}

		private void CategoryReadCompleted(object sender, OpenReadCompletedEventArgs e)
		{
			if (e.Error != null || e.Cancelled)
			{
				MessageBox.Show("Error Getting Category Children");
				return;
			}

			var list = ViewModelBase.DeserializeJson<CategoryViewModel>(e.Result);
			this.Children.AddRange(list);

			var wc = new WebClient();
			wc.OpenReadCompleted += this.ImageReadCompleted;
			wc.OpenReadAsync(new Uri(string.Format("{0}?QType=NextImgChildren&IDCat={1}", UrlHelper.QueryURl, this.IDCategory)));
		}

		private void ImageReadCompleted(object sender, OpenReadCompletedEventArgs e)
		{
			if (e.Error != null || e.Cancelled)
			{
				MessageBox.Show("Error Getting Category Children");
				return;
			}

			var list = ViewModelBase.DeserializeJson<ImageViewModel>(e.Result);
			this.Children.AddRange(list);
		}
	}
}