﻿using System;
using System.Net;
using Telerik.Windows.Data;
using System.Windows;
using System.Diagnostics;
using TreeViewAndJSON.Helpers;

namespace TreeViewAndJSON.ViewModels
{
	public class MainViewModel
	{
		private readonly RadObservableCollection<CategoryViewModel> categories;
		public MainViewModel()
		{
			this.categories = new RadObservableCollection<CategoryViewModel>();
			
			var webClient = new WebClient();
			webClient.OpenReadCompleted += this.BaseCategoryReadCompleted;
			webClient.OpenReadAsync(new Uri(string.Format("{0}?QType=AllBaseCats", UrlHelper.QueryURl)));
		}
		private void BaseCategoryReadCompleted(object sender, OpenReadCompletedEventArgs e)
		{
			Debug.Assert(e.Error == null && !e.Cancelled);
			this.categories.AddRange(ViewModelBase.DeserializeJson<CategoryViewModel>(e.Result));
		}
		public RadObservableCollection<CategoryViewModel> Categories
		{
			get
			{
				return this.categories;
			}
		}
	}
}